//-----------------------------------------------------------------------------
//
//  $Id: NsoundAll.h 910 2015-07-09 03:05:58Z weegreenblobbie $
//
//  Nsound is a C++ library and Python module for audio synthesis featuring
//  dynamic digital filters. Nsound lets you easily shape waveforms and write
//  to disk or plot them. Nsound aims to be as powerful as Csound but easy to
//  use.
//
//  Copyright (c) 2004 - 2007 Nick Hilton
//
//  weegreenblobbie_at_yahoo_com
//
//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//
//  This program is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Library General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
//
//-----------------------------------------------------------------------------

#ifndef _NSOUND_ALL_H_
#define _NSOUND_ALL_H_

#include <Nsound/Nsound.h>
#include <Nsound/AudioPlayback.h>
#include <Nsound/AudioPlaybackRt.h>
#include <Nsound/AudioStream.h>
#include <Nsound/AudioStreamSelection.h>
#include <Nsound/Buffer.h>
#include <Nsound/BufferSelection.h>
#include <Nsound/BufferWindowSearch.h>
#include <Nsound/CircularBuffer.h>
#include <Nsound/Clarinet.h>
#include <Nsound/Cosine.h>
#include <Nsound/DelayLine.h>
#include <Nsound/DrumBD01.h>
#include <Nsound/DrumKickBass.h>
#include <Nsound/EnvelopeAdsr.h>
#include <Nsound/FFTChunk.h>
#include <Nsound/FFTransform.h>
#include <Nsound/Filter.h>
#include <Nsound/FilterAllPass.h>
#include <Nsound/FilterBandPassFIR.h>
#include <Nsound/FilterBandPassIIR.h>
#include <Nsound/FilterBandPassVocoder.h>
#include <Nsound/FilterBandRejectFIR.h>
#include <Nsound/FilterBandRejectIIR.h>
#include <Nsound/FilterCombLowPassFeedback.h>
#include <Nsound/FilterDelay.h>
#include <Nsound/FilterDC.h>
#include <Nsound/FilterHighPassFIR.h>
#include <Nsound/FilterHighPassIIR.h>
#include <Nsound/FilterIIR.h>
#include <Nsound/FilterLeastSquaresFIR.h>
#include <Nsound/FilterLowPassFIR.h>
#include <Nsound/FilterLowPassIIR.h>
#include <Nsound/FilterLowPassMoogVcf.h>
#include <Nsound/FilterMovingAverage.h>
#include <Nsound/FilterFlanger.h>
#include <Nsound/FilterParametricEqualizer.h>
#include <Nsound/FilterPhaser.h>
#include <Nsound/FilterSlinky.h>
#include <Nsound/FilterStageIIR.h>
#include <Nsound/FilterTone.h>
#include <Nsound/FluteSlide.h>
#include <Nsound/Generator.h>
#include <Nsound/GeneratorDecay.h>
#include <Nsound/Granulator.h>
#include <Nsound/GuitarBass.h>
#include <Nsound/Hat.h>
#include <Nsound/Instrument.h>
#include <Nsound/Kernel.h>
#include <Nsound/Mesh2D.h>
#include <Nsound/MeshJunction.h>
#include <Nsound/Mixer.h>
#include <Nsound/OrganPipe.h>
#include <Nsound/Plotter.h>
#include <Nsound/Pluck.h>
#include <Nsound/Pulse.h>
#include <Nsound/RandomNumberGenerator.h>
#include <Nsound/ReverberationRoom.h>
#include <Nsound/RngTausworthe.h>
#include <Nsound/Sawtooth.h>
#include <Nsound/Sine.h>
#include <Nsound/Spectrogram.h>
#include <Nsound/Square.h>
#include <Nsound/StreamOperators.h>
#include <Nsound/Stretcher.h>
#include <Nsound/TicToc.h>
#include <Nsound/Triangle.h>
#include <Nsound/Utils.h>
#include <Nsound/Vocoder.h>
#include <Nsound/Wavefile.h>
#include <Nsound/WindowType.h>

#endif

// :mode=c++: jEdit modeline

